//=============================================================================================================================
//
// Copyright (c) 2015-2019 VisionStar Information Technology (Shanghai) Co., Ltd. All Rights Reserved.
// EasyAR is the registered trademark or trademark of VisionStar Information Technology (Shanghai) Co., Ltd in China
// and other countries for the augmented reality technology developed by VisionStar Information Technology (Shanghai) Co., Ltd.
//
//=============================================================================================================================

import UIKit
import EasyARSwift

//
// Steps to create the key for this sample:
//  1. login www.easyar.com
//  2. create app with
//      Name: HelloAR
//      Bundle ID: cn.easyar.samples.helloar
//  3. find the created item in the list and show key
//  4. set key string bellow
//
let key = "===PLEASE ENTER YOUR KEY HERE==="

@UIApplicationMain
internal class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?

    static func displayToastWithMessage(_ toastMessage: String) -> Void {
        OperationQueue.main.addOperation {
            let keyWindow = UIApplication.shared.keyWindow!
            let toastView = UILabel()
            toastView.text = toastMessage
            toastView.textAlignment = NSTextAlignment.center
            toastView.textColor = UIColor.white
            toastView.lineBreakMode = NSLineBreakMode.byWordWrapping
            toastView.numberOfLines = 0
            toastView.frame = CGRect(x: 0, y: 0, width: keyWindow.frame.size.width / 2, height: 200)
            toastView.layer.cornerRadius = 10
            toastView.layer.masksToBounds = true
            toastView.center = keyWindow.center

            keyWindow.addSubview(toastView)
            UIView.animate(withDuration: 10, delay: 10, options: UIView.AnimationOptions.curveLinear, animations: { toastView.alpha = 0 }) { (finished) in toastView.removeFromSuperview() }
        }
    }

    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        if !Engine.initialize(key) {
            print("Initialization Failed.")
            AppDelegate.displayToastWithMessage(Engine.errorMessage())
        }
        return true
    }

    func applicationWillResignActive(_ application: UIApplication) {
        Engine.onPause()
    }

    func applicationDidEnterBackground(_ application: UIApplication) {
    }

    func applicationWillEnterForeground(_ application: UIApplication) {
    }

    func applicationDidBecomeActive(_ application: UIApplication) {
        Engine.onResume()
    }

    func applicationWillTerminate(_ application: UIApplication) {
    }
}
